=== examples/skyway_for_ros_examples/requirements.txt ===
black==22.8.0
