=== debian/changelog ===
ros-noetic-skyway (0.0.2-1focal) focal; urgency=high

  * Output logs when loading and unloading plugins

 -- Toshiya Nakakura <t.nakakura@ntt.com>  Wed, 05 Apr 2023 15:00:00 -0000

ros-noetic-skyway (0.0.1-1focal) focal; urgency=high

  first release

 -- Nakakura <t.nakakura@ntt.com>  Tue, 28 Mar 2023 15:00:00 -0000
